unit OSCPU;
{ ࠡ⪨ }
interface
  {㭪 믮 1 ⠪}
  Function DoTakt:boolean;

implementation

uses OSData,OSProc,OSSVTime,OSIOCPU,OSSVMEM;

Function VerifyAddress(var Address:TypeAdress):boolean;
begin
  if (Address<MCB[Process[CurProc].FirstMCB].First)  or
    (Address>=MCB[Process[CurProc].FirstMCB].First+
      MCB[Process[CurProc].FirstMCB].Size) Then VerifyAddress:=FALSE;
end;

procedure Do_Operation(CodOperation:TypeCodOp; Operand1:TypeOperand;
  var Operand2:TypeOperand);
begin
  case (CodOperation) of
    CODOP_ARITHMETICAL:
      begin
        if (not VerifyAddress(Operand1)) or (not VerifyAddress(Operand2)) Then
          DeleteProcess(CurProc);
      end;
    CODOP_IO: InitIO;
    CODOP_ASK_MEM: ASkMem;
    CODOP_FREE_MEM:FreeMem;
    CODOP_EXIT:
      begin
      Inc(T_mono,GetT_mono(Process[CurProc].N_cmnd,Process[CurProc].D_InOut,Process[CurProc].N_InOut));
      Inc(M_multi);
      DeleteProcess(CurProc);
      end;

  end;
end;



Procedure Get_CodOperation_Adress1_Adress2(Command:TypeCommand;
  var CodOperation:TypeCodOp;var MathAdress1,MathAdress2:TypeAdress
  );{ઠ }
begin
  CodOperation:=TypeCodOp(Command);
  if (GenerateWrongAddress) Then
  begin
    MathAdress1:=MCB[Process[CurProc].FirstMCB].Size+10;
    MathAdress2:=MCB[Process[CurProc].FirstMCB].Size+10;
    GenerateWrongAddress:=FALSE;
  end
  else
  begin
    MathAdress1:=random(MCB[Process[CurProc].FirstMCB].Size);
    MathAdress2:=random(MCB[Process[CurProc].FirstMCB].Size);
  end;

end;


Function GenerateCommand:TypeCommand;
var com:TypeCommand;
    n:integer;
    r,MAX_PC_IO:real;
begin
  {᭠砫 ⠥,   䬥᪠}
  com:=COMMAND_ARITHMETICAL;
  randomize;
  r:=random;
  {  -뢮}
  if (r<=Process[CurProc].D_InOut/100) or
    (Process[CurProc].N_Cmnd-Cmnd-1<=
      Process[CurProc].N_Cmnd*(Process[CurProc].D_InOut/100)-(Process[CurProc].PC_IO-T_Load))
   then
    com:=COMMAND_IO;

  MAX_PC_IO:=Process[CurProc].N_Cmnd*Process[CurProc].D_InOut/100;
  if (Process[CurProc].PC_IO>=MAX_PC_IO+T_Load) and (com=COMMAND_IO) Then com:=COMMAND_ARITHMETICAL;


  {    ᢮ ⥫쭮 }
  if (com=COMMAND_ARITHMETICAL) Then
  begin
    {   ⥫쭮 }
    if( (r<=Process[CurProc].N_ask_mem/Process[CurProc].N_cmnd)
       or (Process[CurProc].N_Cmnd-Cmnd-MAX_PC_IO-Process[CurProc].N_ask_mem-Process[CurProc].N_free_mem<=0))
       and (Process[CurProc].Cur_ask_mem<Process[CurProc].N_ask_mem)
       Then
      com:=COMMAND_ASK_MEM
    else
    begin
      com:=COMMAND_ARITHMETICAL;
      {  ᢮ ⥫쭮 }
      if( (r<=Process[CurProc].N_free_mem/Process[CurProc].N_cmnd)
       or (Process[CurProc].N_Cmnd-Cmnd-MAX_PC_IO-Process[CurProc].N_free_mem<=0))
       and (Process[CurProc].Cur_free_mem<Process[CurProc].N_free_mem)
       AND (Process[CurProc].Cur_ask_mem>Process[CurProc].Cur_free_mem)
      Then
        com:=COMMAND_FREE_MEM

    end;
  end;

  if (Process[CurProc].N_Cmnd=Cmnd) then com:=COMMAND_EXIT;
  GenerateCommand:=com;
end;

Procedure  GetRealAdres(MathAdres:TypeAdress; var RealAdres:TypeAdress);
begin
  RealAdres:=MathAdres+MCB[Process[CurProc].FirstMCB].First;
end;

Procedure DoCommand;
var Command:TypeCommand;
{    CodOperation:typeCodOp;}{  㫥 OSData }
    MathAdress1,MathAdress2:TypeAdress;
    Operand1,Operand2:TypeOperand;
begin
  Inc(D_NCountSys);
  Inc(Cmnd);
  Command:=GenerateCommand;
    Get_CodOperation_Adress1_Adress2(Command,CodOperation,
      MathAdress1,MathAdress2);
  if (Command=COMMAND_ARITHMETICAL) Then
  begin

    GetRealAdres(MathAdress1,Operand1);
    GetRealAdres(MathAdress2,Operand2);
  end;
    Do_Operation(CodOperation,Operand1,Operand2);

end;

Function ProcessInterrupts:boolean;
var n:integer;
begin
  case (Command) of
    INTR_IO:
    begin
        inc(Process[Intr[endIntr]].IOCmndProcess); {Inc(D_CountSys);}
        ProcessInterrupts:=TRUE;


        if (Process[Intr[endIntr]].IOCmndProcess>=T_IntrIO) then
        begin
          Process[Intr[endIntr]].Condition:=READY;
          inc (Process[Intr[endIntr]].PC_IO);
          {Inc(Process[Intr[endIntr]].Cmnd);}
          Command:=SavedCommand;
          if (Command=WORK) THen Cmnd:=SavedCmnd;
          RemoveInterrupt;
          if (Command=WORK) Then Process[CurProc].Condition:=ACTIVE;
      {   if (Command=WAITING) Then T_CurNext:=SavedCmnd;}
        end;
        Exit;
    end;
    WORK:
    begin
    end ;
    WAITING:
    begin
    end;
    else
    begin ProcessInterrupts:=FALSE;Exit;end;
  end;
  if (FirstIntr<>EndIntr) Then {᫨   । ਮ⮢}
  begin
    SavedCmnd:=Cmnd; {࠭塞 ﭨ ⨢ }
    SavedCommand:=Command;
    if (Command<>WAITING) Then Process[CurProc].Condition:=Saved;

    Process[Intr[EndIntr]].Condition:=FinishingIO;
    Command:=INTR_IO;
    ProcessInterrupts:=TRUE;
    Exit;
  end
  else
  begin
    ProcessInterrupts:=FALSE;
    exit;
  end;
end;

Function DoTakt:boolean;
begin
  Inc(PC);
  if (Moving>0) Then exit;
  LoadProcesses;
  ProcessInterrupts;
  if (Command=WORK) then
  begin
      DoCommand;
{      if (CodOperation=CODOP_ARITHMETICAL) then
      begin
        if (Process[CurProc].Condition=ACTIVE) then
        begin
         Inc(Cmnd);
        { Process[CurProc].Cmnd:=Cmnd;}
{        end
      end;}
  end;
  if (CurKvant>0) then  Dec(CurKvant);
end;

end.