Unit OSInit;
{,  ࠭ 楤 樠樨}
interface
uses OSData,OSPrint,OSProc,Dos;
{楤 樠樨}
Function InitializeProgram:boolean;
implementation

Procedure HideCursor; { }
var Regs: registers;
begin
  with regs do
    begin
      AH:=1;
      CH:=$20;
      CL:=0;
      BH:=0;
      Intr($10,Regs);
    end;
end;

Function InitializeProcessDefault:boolean;
begin
  ProcessDefault.Condition:=READY;
  ProcessDefault.V_Task:=10;
  ProcessDefault.T_Loaded:=T_Load;
  ProcessDefault.D_InOut:=3;{%  IO}
  ProcessDefault.N_InOut:=17;
  ProcessDefault.N_cmnd:=100;
  ProcessDefault.Prior:=10;
  ProcessDefault.PC_IO:=T_Load;
  ProcessDefault.Cmnd:=1;
end;

Procedure GenerateSystemParameter(Parameter:WORD;Section:TSection);
begin
    case (Section ) of
      SEC_V_OZU:
      begin
        OZUSize:=Parameter; OZUFreeSize:=OZUSize;
      end;
      {SEC_V_RAZDEL:V_Razdel:=Parameter;}
      SEC_Kvant:
      begin
        Kvant:=Parameter; CurKvant:=Kvant;
      end;
      SEC_T_Next:T_Next:=Parameter;
      SEC_T_InitIO: T_InitIO:=Parameter;
      SEC_T_IntrIO: T_IntrIO:=Parameter;
      SEC_T_LOAD: T_Load:=Parameter;
      SEC_SPEED: Speed:=Parameter;
      SEC_T_GLOBL: T_Globl:=Parameter;
      SEC_T_MOVE: T_Move:=Parameter;
      SEC_T_ASK_MEM: T_ask_mem:=Parameter;
    end;

end;

Procedure FillGenerateProcessInfo(Section:TSection;Min,Max,Discrete:Word);
begin
  case (Section)Of
  SEC_V_TASK:
  begin
    GenerateProcessInfo.Min.V_Task:=Min;
    GenerateProcessInfo.Max.V_Task:=Max;
    GenerateProcessInfo.Discrete.V_Task:=Discrete;
  end;
  SEC_N_CMND:
  begin
    GenerateProcessInfo.Min.N_Cmnd:=Min;
    GenerateProcessInfo.Max.N_Cmnd:=Max;
    GenerateProcessInfo.Discrete.N_Cmnd:=Discrete;
  end;
  SEC_D_INOUT:
  begin
    GenerateProcessInfo.Min.D_InOut:=Min;
    GenerateProcessInfo.Max.D_InOut:=Max;
    GenerateProcessInfo.Discrete.D_InOut:=Discrete;
  end;
  SEC_N_INOUT:
  begin
    GenerateProcessInfo.Min.N_InOut:=Min;
    GenerateProcessInfo.Max.N_InOut:=Max;
    GenerateProcessInfo.Discrete.N_InOut:=Discrete;
  end;
  SEC_PRIOR:
  begin
    GenerateProcessInfo.Min.Prior:=Min;
    GenerateProcessInfo.Max.Prior:=Max;
    GenerateProcessInfo.Discrete.Prior:=Discrete;
  end;
  SEC_N_ASK_MEM:
  begin
    GenerateProcessInfo.Min.N_ask_mem:=Min;
    GenerateProcessInfo.Max.N_ask_mem:=Max;
    GenerateProcessInfo.Discrete.N_ask_mem:=Discrete;
  end;
  SEC_N_FREE_MEM:
  begin
    GenerateProcessInfo.Min.N_free_mem:=Min;
    GenerateProcessInfo.Max.N_free_mem:=Max;
    GenerateProcessInfo.Discrete.N_free_mem:=Discrete;
  end;
  SEC_V_ASK_MEM:
  begin
    GenerateProcessInfo.Min.V_ask_mem:=Min;
    GenerateProcessInfo.Max.V_ask_mem:=Max;
    GenerateProcessInfo.Discrete.V_ask_mem:=Discrete;
  end;
  end;
end;

Function ReadFile:boolean;
  var F:TEXT;
  min,Max,Discrete,Parameter:longint;
  Section:TSection;
  str1:String;
begin
  RandSeed:=30;
  Section:=SEC_V_Ozu;
  Assign(F,InputFileName);
  Reset(F);
  while (Section<>SEC_V_Task) do
  begin
    Read(F,Min,MAX,Discrete);
    if (Discrete=0) Then Discrete:=1;
    Parameter:=Min+((Random(Max-Min) )DIV Discrete )*Discrete;
    GenerateSystemParameter(Parameter,Section);
    Inc(Section);
    readln(F);
  end;
  Readln(F,str1);
  Readln(F,str1);
  while (not Eof(F)) do
  begin
    Read(F,Min,MAX,Discrete);
    if (Discrete=0) Then Discrete:=1;
     Parameter:=Min+((Random(Max-Min) )DIV Discrete )*Discrete;
    FillGenerateProcessInfo(Section,Min,Max,Discrete);
    Inc(Section);
    if (Section=SEC_END) Then break;
    Readln(f);
  end;
  Close(F);

  ReadFile:=TRUE;

end;

Function InitializeProgram:boolean;
var n:integer;
begin
  {ࠡ⪠ ࠬ஢   ப}
  For n:=ParamCount downto 1 do
  begin
   if (ParamStr(n)='/?' )then ShowHelp;
  end;


  Quit:=FALSE;
  Speed:=1.0;{1 ⠪  ᥪ㭤 砫쭠 ᪮}
  NextTask_ID:=1;
  Kvant:=10;{᫮ ⠪⮢ ஢, 㯭   ﭨ
                   );}
  CurKvant:=Kvant;
  {樠 }
  Command:=WAITING;
  CurProc:=-1;
  LastCountTiks:=CountTiks;
  T_Load:=10;
  T_Next:=5;
  T_InitIO:=3;
  T_IntrIO:=4;
  InitializeProcessdefault;

  OZUSize:=1000;
  OZUFreeSize:=OZUSize;

   for n:=0 to MAX_PROCESS do Process[n].Condition:=NONE;
  {GenerateProcesses;}
  ProcessDefault.T_Loaded:=0;
  ProcessDefault.PC_IO:=0;
  ProcessDefault.Condition:=LOAD;
  ProcessesBoxX:=1;
  ProcessesBoxY:=1;
  CPUBoxX:=20;
  CPUBoxY:=3+MAX_PROCESS;
  SystemBoxX:=58;
  SystemBoxY:=3+MAX_PROCESS;
  SettingsBoxX:=38;
  SettingsBoxY:=3+MAX_PROCESS;
  HideCursor;
  ControlBoxX:=1;
  ControlBoxY:=3+MAX_PROCESS;
  QueueProcessesBoxX:=1; QueueProcessesBoxY:=24;
  ReadFile;
  AutomaticLoadProcesses:=TRUE;
  D_sys:=100;
  if (T_Load>0) Then Loading:=T_Load else Loading:=0;
  {樠 MCB}
  for n:=1 to MAX_MCB do
  begin
    FreeMCB[n]:=n;
    {BusyMCB[n]:=0;}
  end;
  FreePos:=1;
  BusyPos:=0;

  GenerateDefaultProcessParameters;
  GenerateProcesses;
  T_CurNext:=T_next;
end;

end.