Unit OSKeys;
{ ࠡ⪨   ஬}
interface
  uses OSData,Crt;
  { 㭪 ࠡ⪨  }
  Function ProcessKeys:boolean;
implementation
uses OSPrint,OSProc,OSSVTIME;{ 㭪樨 ReadKey}

Procedure ProcessMinus;
var n,m:integer;
begin
  if (Speed>MinSpeed) then
  begin
    m:=Round(Speed /18);
    Speed:=Speed*(1-SpeedChangeStep);
    n:=Round(Speed /18);
    if ((Speed>=18) and (Speed*(1+SpeedChangeStep)>18)) then
    begin
      m:=TaktBeforeDelay;
      LastCounttiks:=CountTiks;
    end;
    if (Speed>=18) then
    begin
      TaktBeforeDelay:=n-(m-TaktBeforeDelay);
    end;
  end;
end;

Procedure ProcessPlus;
var n,m:integer;
begin
  if (Speed<MaxSpeed) then
  begin
    m:=Round(Speed /18);
    Speed:=Speed*(1+SpeedChangeStep);
    n:=Round(Speed /18);
    if ((Speed>=18) and (Speed*(1-SpeedChangeStep)<18)) then
    begin
      m:=TaktBeforeDelay;
      LastCounttiks:=CountTiks;
    end;
    if (Speed>=18) then
    begin
      TaktBeforeDelay:=n-(m-TaktBeforeDelay);
    end;

  end;
end;

Procedure ProcessDown;
begin
  case View of
  VIEW_TIME,VIEW_MEMORY:
  begin;
    SelectedProcess:=(SelectedProcess+1) mod (MAX_PROCESS+1);
  end;
  VIEW_TABLEMEMORY:
  begin
    Inc(TableScrollValue);
    if (TableScrollValue>=OZUSize) Then TableScrollValue:=OZUSize-1;
  end;
  end;
end;

Procedure ProcessUp;
begin
  case View of
  VIEW_TIME,VIEW_MEMORY:
  begin
    Dec(SelectedProcess);
    if (SelectedProcess<0) Then SelectedProcess:=MAX_PROCESS;
  end;
  VIEW_TABLEMEMORY:
  begin
    Dec(TableScrollValue);
    if (TableScrollValue>=OZUSize) Then TableScrollValue:=0;
  end;
  end;
end;

Procedure ProcessDelete;
begin
  if (SelectedProcess=CurProc) Then ChangeProcess;
  DeleteProcess(SelectedProcess);
end;

Procedure ProcessLeft;
begin
  case View of
  VIEW_TIME:
  begin
    Dec(SelectedParam);
    if (SelectedParam<0) Then SelectedParam:=MAX_TIMEPARAMS;
  end;
  VIEW_MEMORY:
  begin
    Dec(SelectedParam);
    if (SelectedParam<=MAX_TIMEPARAMS) Then SelectedParam:=MAX_PARAMS;

  end;
  end;
  CurrentNumber:=0;
end;

Procedure ProcessRight;
begin
   case View of
   VIEW_TIME:
   begin
     SelectedParam:=(SelectedParam+1) mod( MAX_TIMEPARAMS+1);

   end;
   VIEW_MEMORY:
   begin
     SelectedParam:=(SelectedParam+1) mod( MAX_PARAMS+1);
     if (SelectedParam<=MAX_TIMEPARAMS) Then SelectedParam:=MAX_TIMEPARAMS+1;
   end;
   end;
   CurrentNumber:=0;
end;

Procedure ProcessNumber(Ch:char);
var  Number:integer;
begin

  Number:=integer(integer(Ch)-ord('0'));
  if (CurrentParam*10+Number>65535) Then CurrentNumber:=0;
  if (CurrentNumber=0) Then
  begin
    if (Number=0) Then exit;
    case (SelectedParam) of
      0:ProcessDefault.V_Task:=Number;
      1:ProcessDefault.N_cmnd:=Number;
      2:ProcessDefault.D_InOut:=Number;
      3:ProcessDefault.N_InOut:=Number;
      4:ProcessDefault.Prior:=Number;
      5:ProcessDefault.N_ask_mem:=Number;
      6:ProcessDefault.N_free_mem:=Number;
      7:ProcessDefault.V_ask_mem:=Number;
    end;
    CurrentParam:=Number;
    CurrentNumber:=1;
  end
  else
  begin
    case (SelectedParam) of
      0:ProcessDefault.V_Task:=ProcessDefault.V_Task*10+Number;
      1:ProcessDefault.N_cmnd:=ProcessDefault.N_cmnd*10+Number;
      2:ProcessDefault.D_InOut:=ProcessDefault.D_InOut*10+Number;
      3:ProcessDefault.N_InOut:=ProcessDefault.N_InOut*10+Number;
      4:ProcessDefault.Prior:=processDefault.Prior*10+Number;
      5:ProcessDefault.N_ask_mem:=processDefault.N_ask_mem*10+Number;
      6:ProcessDefault.N_free_mem:=processDefault.N_free_mem*10+Number;
      7:ProcessDefault.V_ask_mem:=processDefault.V_ask_mem*10+Number;
    end;
    CurrentParam:=CurrentParam*10+Number;
    Inc(CurrentNumber);
    if (CurrentNumber>=5) Then CurrentNumber:=0;
  end;

end;

Procedure ProcessN;
begin
  ProcessDefault.V_Task:=ProcessDefault.V_Task;
  ProcessDefault.N_cmnd:=processDefault.N_cmnd;
  ProcessDefault.D_InOut:=processDefault.D_InOut;
  ProcessDefault.N_InOut:=ProcessDefault.N_InOut;
  ProcessDefault.Prior:=ProcessDefault.Prior;

  if (ProcessDefault.N_cmnd<>0) and
    (ProcessDefault.V_Task<>0) and
    (ProcessDefault.D_InOut<100) and
    (ProcessDefault.Prior>0) and (ProcessDefault.Prior<4095) then
        GenerateProcess;
end;

Procedure ProcessC;
begin
  if (AutomaticLoadProcesses) Then AutomaticLoadProcesses:=FALSE
  else AutomaticLoadProcesses:=TRUE;
end;

Procedure ProcessF10;
begin
  if (AutoQuit) Then AutoQuit:=FALSE else AutoQuit:=TRUE;
end;

Procedure ProcessTab;
begin
{  if (View=VIEW_TIME) Then
  begin
    View:=VIEW_MEMORY;
    Selectedparam:=MAX_TIMEPARAMS+1;
  end
  else
  begin
    View:=VIEW_TIME;
    SelectedParam:=0;
  end;}
  Inc(View);
  if (View=TVIEW(integer(VIEW_TABLEMEMORY)+1)) Then View:=VIEW_TIME;
  case View of
    VIEW_MEMORY:  SelectedParam:=MAX_TIMEPARAMS+1;
    VIEW_TIME:   SelectedParam:=0;
    else SelectedParam:=0;

  end;
  clrscr;
end;

procedure ProcessPageUp;
begin
  Dec(TableScrollValue,ScrollStep);
  if (TableScrollValue>=OZUSize) Then TableScrollValue:=0;

end;

Procedure ProcessPageDown;
begin
  Inc(TableScrollValue,ScrollStep);
  if (TableScrollValue>=OZUSize) Then TableScrollValue:=OZUSize-1;
end;

Procedure ProcessW;
begin
  GenerateWrongAddress:=TRUE;
end;

Function ProcessKeys:boolean;
var Ch:char;
begin
  Ch:=ReadKey;
  case (Ch) of
    KeyEsc: Quit:=TRUE;
    KeyPlus: ProcessPlus  ;
    KeyMinus: ProcessMinus;
    KeyF1: ShowHelp;
    'n','N': ProcessN;
    KeyDown:ProcessDown;
    KeyUp:ProcessUp;
    KeyDelete:ProcessDelete;
    KeyLeft:ProcessLeft;
    KeyRight:ProcessRight;
    '0'..'9':ProcessNumber(Ch);
    'c','C': ProcessC;
    KeyF10: ProcessF10;
    KeyTab:ProcessTab;
    KeyPageUp:ProcessPageUp;
    KeyPageDown:ProcessPageDown;
    'w','W':ProcessW;
  end;
end;

end.